#include <iostream>
using namespace std;
#include "ezwin.h"
#include "rect.h"
#include <stdlib.h>
#include <string>
#include <cassert>
#include <ctime>
#include "MSGraphics.cpp"
#include "Highscores.cpp"
#include "Highscoresdisplay.cpp"
#define MAXSIZE 25
#define a strfield


/* prototypes of functions used in the program
   ------------------------------------------- */

int Newgame(const Position&);	// function that loads a new game
int Choice(const Position&); 	// function that checks the choice that you have inputted
void GamePlay();		// function that includes actual Gameplay
void load_menu();   		// function that creates menu
void load_GUI();		// function that creates GUI
void load_map();		// function that creates the minefield in the grid
void displayfield();		// function that displays the minefield in the grid
void displayzero(int,int);	// function that opens the neighbouring boxes in case the value of the box is zero(ie,blank box)
void display_scores();		// function that displays the high score menu
void displayminenum();	// variables to display number of mines in a difficulty level


/* Declaring some varibles required in the code
   -------------------------------------------- */


int firstclick=1;			// to ascertain whether the click is a firstclick
char s[5];				// character array to display timer
int elapsed_time;			// variable used for the proper working of timer
int i,j;				// loop variales used throughout the program
int x,y;				// variables to give position of the Box in the Minesweeper Grid
int m1,m2;			// variables to display number of mines in a difficulty level
float menux, menuy; 			// variables to give position of mouseclick in GameWindow.
float xcoord, ycoord;			// variables to give position (coordinates) of mouse click in GameWindow.
float srow,scol,erow,ecol; 		// variables that determine the position of the gamebox
string strfield[MAXSIZE][MAXSIZE];	// array to give value of each box in the grid (in string format)
string flag[MAXSIZE][MAXSIZE];		// array to store status of box - whether it is flagged or not
string status[MAXSIZE][MAXSIZE];	// variables to give status of box - "Hidden" = Deactive in the display,"Visible" = Active in the display
string Mode;				// Declaring Mode as String - GameMode or FlagMode
int mines;          			// variable that stores the no. of mines present in the grid
int row;        			// variable that stores the no. of rows of the grid
int col;        			// variable that stores the no. of columns of the grid
int field[MAXSIZE][MAXSIZE]; 		// array that holds the mines and the field





#include "Stopwatch.cpp"			// function that displays the time elapsed





/*The following funtion "MouseClick" is invoked when the mouse is clicked in GameWindow.
It checks the coordinates of the Mouse Click, identifies the window & proceeds by calling the respective function
---------------------------------------------------------------------------------------------------------------------*/


int MouseClick(const Position &p)
{
	// extracting the x & y coordinates of the mouse click
	xcoord = p.GetXDistance();
	ycoord = p.GetYDistance();

	if (Restart.IsInside(p))						//Checking whether mouse click is inside Restart Button
	{
		GameWindow.StopTimer();
		load_menu();
		firstclick=1;
		GameWindow.SetMouseClickCallback(Choice);
	}
	else if (xcoord > 23.5 && xcoord < 27.5 && ycoord > 5.5 && ycoord < 9) 	//Checking whether mouse click is inside Game & Flag Mode Swap Rectangle
	{
		if (Mode == "FlagMode")
		{
			Mode="GameMode";			
			GameWindow.RenderRectangle(Position(23.5,5.5), Position(27.5,9),Black,true);
			GameWindow.RenderText(Position(24,6), Position(27,6), "Game Mode", Green ,Black);
			GameWindow.RenderText(Position(24,6.5), Position(27,6.5), "is Active", White ,Black);
			GameWindow.RenderText(Position(24,7.5), Position(27,7.5), "Press to swap to", White ,Black);
			GameWindow.RenderText(Position(24,8), Position(27,8), "Flag Mode", Red ,Black);
		}
		else if(Mode == "GameMode")
		{
			Mode="FlagMode";
			GameWindow.RenderRectangle(Position(23.5,5.5), Position(27.5,9),Black,true);
			GameWindow.RenderText(Position(24,6), Position(27,6), "Flag Mode", Red ,Black);
			GameWindow.RenderText(Position(24,6.5), Position(27,6.5), "is Active", White ,Black);
			GameWindow.RenderText(Position(24,7.5), Position(27,7.5), "Press to swap to", White ,Black);
			GameWindow.RenderText(Position(24,8), Position(27,8), "Game Mode", Green ,Black);
		}
	}

	
	else if (xcoord > scol && xcoord < ecol && ycoord > srow && ycoord < erow)	// Checking whether the mouse click is inside the Game Grid
	{
		GamePlay(); // GamePlay function is called if the click is inside the minefield
	}
	return 0;
}


/*This function restarts the game or exits from the game depending on the user's choice.
It is used to select the choice from the options availabe after you win or lose a game 
--------------------------------------------------------------------------------------- */


int Newgame(const Position &n)
{
	if (Restart.IsInside(n))			//Checking whether mouse click is inside Restart Button
	{
		GameWindow.StopTimer();
		load_menu();
		firstclick=1;
		GameWindow.SetMouseClickCallback(Choice);
	}
	if  (Signout.IsInside(n))			//Checking whether mouse click is inside Quit Button
	{
		GameWindow.Close();
	}
}





/* "HSMenu" function is used to select the choice from the options available in the screen 
   that appears once you click the Highscores button
--------------------------------------------------------------------------------------- */

int HSMenu(const Position &q)
{
	if(BackBttn.IsInside(q))			// Checking whether mouse click is inside Back Button
	{
		load_menu();
		firstclick=1;
		GameWindow.SetMouseClickCallback(Choice);
	}
}






/*  The following funtion "Choice" is invoked when the mouse is clicked in the GameWindow.
   It checks the coordinates of the Mouse Click, identifies the choice & proceeds by defining respective variables
---------------------------------------------------------------------------------------------------------------------*/

int Choice(const Position &m)
{

	if (Recruit.IsInside(m)) 		//Checking whether mouse click is inside Recruit Level Button
	{
		row=7;
		col=7;
		mines=8;
		scol=11;
		srow=4;
		ecol=18;
		erow=11;
		load_GUI();
		GameWindow.SetMouseClickCallback(MouseClick);
	}
	else if (Regular.IsInside(m)) 	//Checking whether mouse click is inside Regular Level Button
	{
	    	row=11;
	    	col=11;
	    	mines=20;
	    	scol=9;
	    	srow=2;
	    	ecol=20;
	    	erow=13;
		load_GUI();
		GameWindow.SetMouseClickCallback(MouseClick);
    	}

	else if (Veteran.IsInside(m)) 		//Checking whether mouse click is inside Veteran Level Button
	{
		row=15;
		col=15;
		mines=45;
		scol=7;
		srow=0;
		ecol=22;
		erow=15;
		load_GUI();
		GameWindow.SetMouseClickCallback(MouseClick);
        }
	
	else if(Highscore.IsInside(m))		//Checking whether mouse click is inside Highscores Button
		display_scores();

	else if(Signout.IsInside(m))		//Checking whether mouse click is inside Quit Button
		GameWindow.Close();

	return 0;
}




/*	The following function "ApiMain" is the Main function which is executed first.
	It opens the Menu Window & then creates the GUI & loads the minefield in the grid according to the input given by the user
	Also it call the function to be invoked when a mouseclick is made
------------------------------------------------------------------------------------------------------------------------------------*/

int ApiMain()
{
	GameWindow.Open();			// loading gamewindow
	assert(GameWindow.GetStatus() == WindowOpen);
	load_menu();
	firstclick=1;
	GameWindow.SetMouseClickCallback(Choice);
	return 0;
}




/*	The following function "load_menu" creates the Menu Options
	and proceeds by taking the user input and creates the corresponding level
-------------------------------------------------------------------------------------*/


void load_menu()
{
	Background.Load("background3.xpm");
	Background.SetPosition(Position(0,0));
  	Background.Draw();

	// Displaying different menu options

	Recruit.Load("recruit.XPM");
	Recruit.SetPosition(Position(5.2,4));
  	Recruit.Draw();
	Regular.Load("regular.XPM");
	Regular.SetPosition(Position(5,6));
  	Regular.Draw();
	Veteran.Load("veteran.XPM");
	Veteran.SetPosition(Position(5,8));
  	Veteran.Draw();
	Highscore.Load("hsbutton2.xpm");
	Highscore.SetPosition(Position(4.5,10));
	Highscore.Draw();
	Signout.Load("quit.XPM");
	Signout.SetPosition(Position(5.75,12));
	Signout.Draw();
	
}



/*	The following function "load_GUI" creates the Graphic User Interface
	for the minefield using lines & Rectangles
---------------------------------------------------------------------------------*/


void load_GUI()
{
	//Black Rectangle, with border will act as the basic background
	GameWindow.RenderRectangle(Position(0.0,0.0), Position(29.0,15.0), Black, true);
	//an image is loaded which acts as the main background
	Background.Load("apple.XPM");
	Background.SetPosition(Position(0.5,0));
  	Background.Draw();

	//Side menu 1 - New Icon
	Restart.Load("restart.XPM");
	Restart.SetPosition(Position(2,6));
	Restart.Draw();

	//Side menu 2 - Game & Flag Mode Swap Box
	GameWindow.RenderRectangle(Position(23.5,5.5), Position(27.5,9.0), Black , true); 
	GameWindow.RenderText(Position(24,6), Position(27,6), "Game Mode", Green ,Black);
	GameWindow.RenderText(Position(24,6.5), Position(27,6.5), "is Active", White ,Black);
	GameWindow.RenderText(Position(24,7.5), Position(27,7.5), "Press to swap to", White ,Black);
	GameWindow.RenderText(Position(24,8), Position(27,8), "Flag Mode", Red ,Black);
	
	//Number of mines in the game
	
	m1=mines/10;
	m2=mines%10;
	displayminenum();

	//Mine Field
	GameWindow.RenderRectangle(Position(scol,srow),Position(ecol,erow),Blue,false);

	//Black Line;Thickness 0.045 will be used to make boxes
	for(i=scol ;i<=ecol;i++)
	{
		GameWindow.RenderLine(Position(i,srow),Position(i,erow),Black,0.045);
	}
	for(i=srow ;i<=erow;i++)
	{
		GameWindow.RenderLine(Position(scol,i),Position(ecol,i),Black,0.045);
	}


	// Declaring Active Mode
	Mode = "GameMode";

}


/* The displayminenum displays the no. of mines in the chosen difficulty level
------------------------------------------------------------------------------- */

void displayminenum()
{
	Minenum.Load("minesweeperimg.xpm");
	Minenum.SetPosition(Position(22.5,11.5));
	Minenum.Draw();
	switch(m1)
	{
		case 0:
		{
			Num.Load("digit0.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
		case 1:
		{
			Num.Load("digit1.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
		case 2:
		{
			Num.Load("digit2.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
		case 3:
		{
			Num.Load("digit3.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
		case 4:
		{
			Num.Load("digit4.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
		case 5:
		{
			Num.Load("digit5.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
		case 6:
		{
			Num.Load("digit6.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
		case 7:
		{
			Num.Load("digit7.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
		case 8:
		{
			Num.Load("digit8.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
		case 9:
		{
			Num.Load("digit9.xpm");
			Num.SetPosition(Position(25,12));
			Num.Draw();
			break;
		}
	}
	switch(m2)
	{
		case 0:
		{
			Num.Load("digit0.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
		case 1:
		{
			Num.Load("digit1.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
		case 2:
		{
			Num.Load("digit2.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
		case 3:
		{
			Num.Load("digit3.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
		case 4:
		{
			Num.Load("digit4.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
		case 5:
		{
			Num.Load("digit5.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
		case 6:
		{
			Num.Load("digit6.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
		case 7:
		{
			Num.Load("digit7.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
		case 8:
		{
			Num.Load("digit8.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
		case 9:
		{
			Num.Load("digit9.xpm");
			Num.SetPosition(Position(26,12));
			Num.Draw();
			break;
		}
	}
}


/* The "display_scores" function displays the Highscores screen 
----------------------------------------------------------------- */


void display_scores()
{
	GameWindow.RenderRectangle(Position(0,0),Position(29,16),Black,false);
	Background.Load("soldier.XPM");
	Background.SetPosition(Position(4,0));
	Background.Draw();
	Background.Load("hsbutton2.xpm");
	Background.SetPosition(Position(12,1));
	Background.Draw();
	Background.Load("recruit.XPM");
	Background.SetPosition(Position(5.2,2.3));
  	Background.Draw();
	disprec();		// calling a function to display the high scores in that difficulty level
	Background.Load("regular.XPM");
	Background.SetPosition(Position(5,8));
  	Background.Draw();
	dispreg();		// calling a function to display the high scores in that difficulty level
	Background.Load("veteran.XPM");
	Background.SetPosition(Position(21,2.3));
  	Background.Draw();
	dispvet();		// calling a function to display the high scores in that difficulty level
	BackBttn.Load("back.xpm");
	BackBttn.SetPosition(Position(21.7,8));
	BackBttn.Draw();
	GameWindow.SetMouseClickCallback(HSMenu);
	
}




/*	The Following function "GamePlay" is the main part of the project
	It checks the value in strfield
	If the value is
	9 --> Mine
	0 --> There is no mine in the surrounding 8 boxes
	1-8 --> The surrounding boxes contain 1-8 mines respectively
	In the GameMode Mode the function opens that particular box
	In the FlagMode Mode the function display or removes a flag on the box
-------------------------------------------------------------------------------------------*/

void GamePlay()
{
	int ans=0;
	x=ycoord-srow;
	y=xcoord-scol;
	if(firstclick)		// if its the first click then clock is started
	{
		elapsed_time=-1;	
		GameWindow.SetTimerCallback(timer);
		timer();
		GameWindow.StartTimer(1000);
		firstclick=0;
		load_map();
	}
	
	if (Mode == "GameMode")
	{
		if (flag[x][y] == "False")
		{
			status[x][y] = "Visible";
			if (strfield[x][y] == "0")
			{
				displayzero(x,y);
                               
			}
			else if (strfield[x][y] != "9")
			{
				
					GameWindow.RenderRectangle(Position(scol+0.04+y,srow+0.0425+x),Position(scol+0.96+y,srow+0.96+x),White,false);
					GameWindow.RenderText(Position(scol+y+0.5,srow+x+0.5),strfield[x][y],Black);
	
			}
			else if (strfield[x][y] == "9")
			{	
				
				GameWindow.StopTimer();
				displayfield();
				displayyoulose();
				GameWindow.SetMouseClickCallback(Newgame);
				
			}
		}
	}
	else if (Mode == "FlagMode")
	{
		if (flag[x][y] == "False" && status[x][y] == "Hidden")
		{
			displayflag(scol+y+0.1,srow+x+0.1);
			flag[x][y] = "True";
		}
		else if (flag[x][y] == "True")
		{
			GameWindow.RenderRectangle(Position(scol+y+0.1,srow+x+0.1),Position(scol+y+0.9,srow+x+0.9),Blue,false);
			flag[x][y] = "False";
		}
		for(i=0;i<row;i++)
			for(j=0;j<col;j++)
				if(flag[i][j]=="True" &&  strfield[i][j]=="9")
					ans++;
		if(ans==mines)
		{
			
			
			displaywin();
			GameWindow.StopTimer();
			int newscore=(s[0]*10+s[1])*60 + ((s[3])*10 +s[4]);
			high(newscore,mines);
			GameWindow.SetMouseClickCallback(Newgame);
		}
	}
	

}


/*	The following function "displayfield", displays the whole grid.It is invoked if we click on a mine,ie,if we lose.
--------------------------------------------------------------------------------------------------------------------------------*/

void displayfield()
{
	for (i=0;i<row;i++)
	{
		for (j=0; j<col; j++)
		{
			if (flag[i][j] == "False")
			{
				status[i][j] = "Visible";
				if (strfield[i][j] == "9")
				{
					GameWindow.RenderRectangle(Position(scol+j+0.04,srow+i+0.0425),Position(scol+j+0.96,srow+i+0.96),White,false);
					displaymine(j+scol+0.3,i+srow+0.2);
				}
				else if (strfield[i][j] == "0")
					GameWindow.RenderRectangle(Position(scol+j+0.04,srow+i+0.0425),Position(scol+j+0.96,srow+i+0.96),White,false);
				else
				{
					GameWindow.RenderRectangle(Position(scol+j+0.04,srow+i+0.0425),Position(scol+j+0.96,srow+i+0.96),White,false);
					GameWindow.RenderText(Position(j+scol+0.5,i+srow+0.5),strfield[i][j],Black);
				}
			}
		}
	}	
	sleep(4);
}





/*	The following function displays all the blank spaces adjacent to a blank space if a blank space is clicked.
	Also a boundary of numbers surrounding the blank space will also be displayed.
-------------------------------------------------------------------------------------------------------------------------*/


void displayzero(int p,int q)
{
	GameWindow.RenderRectangle(Position(scol+0.04+q,srow+0.0425+p),Position(scol+0.96+q,srow+0.96+p),White,false);
	status[p][q]="Visible";
	
        int u,v;
        for(u=p-1 ; u<=p+1 ; u++)
	{
    		for(v=q-1 ; v<=q+1 ; v++)
    		{
			
			if (u>=0 && v>= 0 && u<row && v<col && flag[u][v] == "False" && status[u][v]=="Hidden" )
			{
			
				if(strfield[u][v]=="0")
					displayzero(u,v);
				else if(strfield[u][v]!="0" )
				{
					GameWindow.RenderRectangle(Position(scol+v+0.04,srow+u+0.0425),Position(scol+v+0.96,srow+u+0.96),White,false);
					GameWindow.RenderText(Position(scol+0.5+v,srow+0.5+u),strfield[u][v],Black);
					status[u][v] = "Visible";continue;
				}
			}
		}
	}
}






/*	The following function "load_map" creates the minefield & loads it in the memory
	It uses the randomize funtion to find random numbers from 0 to a value less than the row size and column size.
	Then it stores it into that position in a 2D array called field[][].
	It also increments the value of the surrounding boxes by 1 signifying that there is a mine in this box
	It stores the value of the boxes in string form in strfield[][]
-------------------------------------------------------------------------------------------------------------------------*/


void load_map()
{

    for (i=0;i<row;i++)
	{
		for (j=0;j<col;j++)
		{
			field[i][j] = 0;
			flag[i][j] = "False";
			status[i][j] = "Hidden";
		}
	}

    srand((unsigned)time(0));
    int r,c;
    for(i=0;i<mines;i++)
	{
		r=rand()%row;
		c=rand()%col;
		/*The following if conditions are written in order to avoid losing in the first click.
		The position of the first click is extracted and then a field is loaded in such a way that the clicked box will always be a blank box*/		
		if(r==x-1 && c==y-1)
		{
			i--;
			continue;
		}
		if(r==x-1 && c==y)
		{
			i--;
			continue;
		}
		if(r==x-1 && c==y+1)
		{
			i--;
			continue;
		}
		if(r==x && c==y-1)
		{
			i--;
			continue;
		}
		if(r==x && c==y)
		{
			i--;
			continue;
		}
		if(r==x && c==y+1)
		{
			i--;
			continue;
		}
		if(r==x+1 && c==y-1)
		{
			i--;
			continue;
		}
		if(r==x+1 && c==y)
		{
			i--;
			continue;
		}
		if(r==x+1 && c==y+1)
		{
			i--;
			continue;
		}
		if(field[r][c]==9)
		{
            		i--;
            		continue;
        	}
        	else
            		field[r][c]=9;
    }

    for(i=0;i<row;i++)
        {
            for(j=0;j<col;j++)
            {
                if(field[i][j]==9)
                   {
		/*The following if conditions is used to avoid the loop from goin outside the boundaries of the 2D array */
                       if((i-1)>=0 && (j-1)>=0)
                       {
                           if(field[i-1][j-1]!=9)
                           field[i-1][j-1]++;
                       }
                       if((i-1)>=0)
                       {
                           if(field[i-1][j]!=9)
                           field[i-1][j]++;
                       }
                       if((i-1)>=0 && (j+1)<col)
                       {
                           if(field[i-1][j+1]!=9)
                           field[i-1][j+1]++;
                       }
                       if((j-1)>=0)
                       {
                           if(field[i][j-1]!=9)
                           field[i][j-1]++;
                       }
                       if((j+1)<col)
                       {
                           if(field[i][j+1]!=9)
                           field[i][j+1]++;
                       }
                       if((i+1)<row && (j-1)>=0)
                       {
                           if(field[i+1][j-1]!=9)
                           field[i+1][j-1]++;
                       }
                       if((i+1)<row)
                       {
                           if(field[i+1][j]!=9)
                           field[i+1][j]++;
                       }
                       if((i+1)<row && (j+1)<col)
                       {
                           if(field[i+1][j+1]!=9)
                           field[i+1][j+1]++;
                       }
                   }
            }
        }
    /*Stores the string value of the boxes into a 2D array */
    for (i=0;i<row;i++)
	{
		for (j=0;j<col; j++)
		{
			strfield[i][j] = field[i][j] + 48;

		}
	}

}



//----------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------
